#define _GNU_SOURCE
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <errno.h>

#include "uhumenu.h"

static void dump (const struct menu *menu, const char *path)
{
	int i, l;
	int fd;
	char buf[PATH_MAX];

	for (i = 0; i < menu->nr; i++) {
		sprintf(buf, "%s%s", path, menu->items[i].file_name);
		if (!menu->items[i].issubmenu) {
			l = strlen(buf);
			if (l < 8 || strcmp(buf + l - 8, ".desktop")) strcpy(buf + l, ".desktop");
		} else {
			mkdir(buf, 0777);
			sprintf(buf, "%s%s/.directory", path, menu->items[i].file_name);
		}
		fd = creat(buf, 0666);
		if (strncmp(menu->items[i].file_content, "[Desktop Entry]", 15)) write(fd, "[Desktop Entry]\n", 16);
		write(fd, menu->items[i].file_content, menu->items[i].file_size);
		close(fd);
		if (menu->items[i].issubmenu) {
			dump(menu->items[i].submenu, path);
		}
	}
}

int create_menu (const struct menu *menu, const char *path)
{
	empty_dir(path);
	dump(menu, path);
	return 0;
}

